<template>
  <el-breadcrumb class="app-breadcrumb" separator="/">
    <transition-group name="breadcrumb">
      <el-breadcrumb-item v-for="(item, index) in levelList" :key="item.path">
        <span
          v-if="item.redirect === 'noRedirect' || index == levelList.length - 1"
          class="no-redirect"
        >
          {{ item.meta.title }}
        </span>
        <a v-else @click.prevent="handleLink(item)">{{ item.meta.title }}</a>
      </el-breadcrumb-item>
    </transition-group>
  </el-breadcrumb>
</template>

<script>
import { mapGetters } from "vuex";
export default {
  data() {
    return {
      levelList: null,
    };
  },
  watch: {
    $route(route) {
      // if you go to the redirect page, do not update the breadcrumbs
      if (route.path.startsWith("/redirect/")) {
        return;
      }
      this.getBreadcrumb();
    },
  },
  computed: {
    ...mapGetters(["sidebarRouters"]),
  },
  created() {
    this.getBreadcrumb();
  },
  methods: {
    getBreadcrumb() {
      // only show routes with meta.title
      let matched = this.$route.matched;
      // 如果是二级页面，归属某个菜单下
      if (this.$route.meta.activeMenu) {
        matched = this.$router.match(this.$route.meta.activeMenu).matched.concat([this.$route]);
      }
      matched = matched.filter((item) => item.meta && item.meta.title);
      const first = matched[0];

      if (!this.isDashboard(first)) {
        matched = [{ path: "/index", meta: { title: "首页" } }].concat(matched);
      }

      this.levelList = matched.filter(
        (item) => item.meta && item.meta.title && item.meta.breadcrumb !== false
      );
    },
    isDashboard(route) {
      return true;
      const name = route && route.name;
      if (!name) {
        return false;
      }
      return name.trim() === "Index";
    },
    handleLink(item) {
      const { redirect, path, name } = item;
      // 1.如有设置redirect属性直接重定向
      if (redirect) {
        this.$router.push(redirect);
        return;
      }
      // 2.先查找菜单路由
      const menuRoute = this.findMenuRouteByName(this.sidebarRouters, name);
      let jumpName;
      // 3.如果菜单路由下面还有菜单，查找落地路由
      if (menuRoute.children?.length > 0) {
        jumpName = this.getFirstPageName(menuRoute.children);
      }
      this.$router.push(jumpName ? { name: jumpName } : path);
    },
    // 根据名称查找菜单路由
    findMenuRouteByName(routes, name) {
      routes = routes.filter((item) => !item.hidden);
      for (let route of routes) {
        if (route.name === name) {
          return route;
        }
        if (route.children) {
          let found = this.findMenuRouteByName(route.children, name);
          if (found) {
            return found;
          }
        }
      }
      return null;
    },
    // 获取菜单第一个实体路由
    getFirstPageName(list) {
      const [first] = list.filter((item) => !item.hidden);
      if (first.children?.length > 0) {
        return getFirstPageName(first.children);
      }
      return first?.name || null;
    },
  },
};
</script>

<style lang="scss" scoped>
.app-breadcrumb.el-breadcrumb {
  display: inline-block;
  font-size: 14px;
  line-height: 50px;
  margin-left: 8px;

  .no-redirect {
    color: #97a8be;
    cursor: text;
  }
}
</style>
